<!DOCTYPE html>

<html lang="en">
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width">
	<title>Plait Webview Docs Source: editor/level_collection.js</title>

	<!--[if lt IE 9]>
	<script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->
	<link type="text/css" rel="stylesheet" href="styles/sunlight.default.css">

	<link type="text/css" rel="stylesheet" href="styles/site.cosmo.css">

</head>

<body>

<div class="navbar navbar-default navbar-fixed-top navbar-inverse">
<div class="container">
	<div class="navbar-header">
		<a class="navbar-brand" href="index.html">Plait Webview Docs</a>
		<button class="navbar-toggle" type="button" data-toggle="collapse" data-target="#topNavigation">
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
        </button>
	</div>
	<div class="navbar-collapse collapse" id="topNavigation">
		<ul class="nav navbar-nav">
			
			<li class="dropdown">
				<a href="namespaces.list.html" class="dropdown-toggle" data-toggle="dropdown">Namespaces<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="socket.html">socket</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="classes.list.html" class="dropdown-toggle" data-toggle="dropdown">Classes<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="Control.html">Control</a></li><li><a href="SessionControl.html">SessionControl</a></li><li><a href="Collection.html">Collection</a></li><li><a href="Overview.html">Overview</a></li><li><a href="Plugins.html">Plugins</a></li><li><a href="Editor.html">Editor</a></li><li><a href="FileMenu.html">FileMenu</a></li><li><a href="Form.html">Form</a></li><li><a href="Routing.html">Routing</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="global.html" class="dropdown-toggle" data-toggle="dropdown">Global<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="global.html#routing">routing</a></li><li><a href="global.html#control">control</a></li><li><a href="global.html#showSessions">showSessions</a></li><li><a href="global.html#TabButton">TabButton</a></li><li><a href="global.html#CueButton">CueButton</a></li><li><a href="global.html#CueBar">CueBar</a></li><li><a href="global.html#form">form</a></li><li><a href="global.html#editor">editor</a></li><li><a href="global.html#addGame">addGame</a></li><li><a href="global.html#createGame">createGame</a></li><li><a href="global.html#removeGame">removeGame</a></li><li><a href="global.html#inputPrompt">inputPrompt</a></li><li><a href="global.html#confirmation">confirmation</a></li><li><a href="global.html#identifyBrowser">identifyBrowser</a></li><li><a href="global.html#generateUUID">generateUUID</a></li><li><a href="global.html#namespace">namespace</a></li>
				</ul>
			</li>
			
		</ul>
        
            <div class="col-sm-3 col-md-3">
                <form class="navbar-form" role="search">
                    <div class="input-group">
                        <input type="text" class="form-control" placeholder="Search" name="q" id="search-input">
                        <div class="input-group-btn">
                            <button class="btn btn-default" id="search-submit"><i class="glyphicon glyphicon-search"></i></button>
                        </div>
                    </div>
                </form>
            </div>
        
	</div>

</div>
</div>


<div class="container" id="toc-content">
<div class="row">

	
	<div class="col-md-12">
	
		<div id="main">
			

		<h1 class="page-title">Source: editor/level_collection.js</h1>
    
<section>
    <article>
        <pre
            class="sunlight-highlight-javascript linenums">/**
* Creates elements for level editing.
* 
* the Level Collection class provides the basic cue schema. Cue schemas from plugins are merged into it.
*
* The config schema is as well defined in this class.
*
* @file level_collection
* @copyright Lasse Marburg 2020
* @license GPLv3
*/
class Level extends Collection {
  constructor(data) {
    super("level", {
      schema:{title:"Level"}, 
      overview:{
        header:["name","_id","config","instances","modified"]
      }
    })

    /** cue schema */
    this.cue = {
      "title": "Cue",
      "headerTemplate": "{{ i1 }} {{ self.path }} {{ self.name }}",
      "type": "object",
      "id": "a_cue",
      "definitions":{},
      "default":{"color":"teal"},
      "properties": {
        "name": {
          "required":true,
          "type": "string",
          "description": "Cue name",
          "propertyOrder": 1
        },
        "color":{
          "type":"string",
          "enum":["teal","tomato","peru","sapphireblue","pearlypurple","orangeyellow","dimgray"],
          "propertyOrder": 1,
          "required":false
        },
        "path": {
          "required":true,
          "readOnly":true,
          "propertyOrder":2002,
          "type":"array",
          "options":{
            "hidden":true
          },
          "items":{
            "type":"string"
          }
        },
        "comment": {
          "type":"string",
          "propertyOrder": 1
        },
        "view": {
          "type": "object",
          "propertyOrder":2001,
          "readOnly": true,
          "required": false,
          "options": {
            "hidden": true
          },
          "descripton": "settings for jointjs view of cue",
          "properties": {
            "id": {
              "type": "string"
            },
            "position": {
              "type": "object",
              "properties": {
                "x": {
                  "type": "number"
                },
                "y": {
                  "type": "number"
                }
              }
            },
            "style":{
              "type":"string",
              "propertyOrder": 3,
              "descripton":"add css style to the cue to give it the looks"
            }
          }
        }
      }
    }
    
    /** chapter schema */
    this.chapter = {
        "title":"|",
        "type":"array",
        "format":"tabs",
        "definitions":{},
        "items":this.cue
      }
    
    /** level schema */
    this.level = {
      "_id": {
        "type":"string",
        "readonly":true
      },
      "name": {
        "type":"string",
        "required":true
      },
      "chapter": {
        "type":"object",
        //"format":"categories",
        //"basicCategoryTitle": "One",
        "properties":this.chapter
      },
      "config": {
        "type":"object",
        "properties":{
          "arguments":{
            "type":"object",
            "description":"add arguments that should be assigned when launching session of this level.",
            "additionalProperties":{
              "type":"object",
              "properties":{
                "collection":{
                  "type":"string",
                  "description":"source collection of default document"
                },
                "query":{
                  "oneOf":[
                    {
                      "type":"string",
                      "description":"mongo find query to default document(s). E.g. {'name':'document name'}",
                      "required":true
                    },
                    {
                      "type":"object",
                      "description":"mongo find query to default documents(s).",
                      "required":true
                    }
                  ]
                }
              }
            }
          }
        }
      },
      "control": {
        "type":"object",
        "properties": {
          "pages":{
            "type":"object",
            "properties":{},
            "additionalProperties": {
              "type":"array",
              "items":{
                "type":"string"
              }
            }
          }
        }
      }
    }
    
    /** store plugins to embedd their cue properties */
    this.plugins = {}
    
    /** store cues to allow for autocomplete */
    this.cuelist = []
    
    this.$launch = $('&lt;button title="Launch Session" class="option_toggle">&lt;i class="fas fa-rocket">&lt;/i>&lt;/button>')
    this.$control_layout = $('&lt;button title="Open Control Layout" class="option_toggle">&lt;i class="fas fa-edit">&lt;/i>&lt;/button>')
    this.$config = $('&lt;button title="Open Level Config" class="option_toggle">&lt;i class="fas fa-cog">&lt;/i>&lt;/button>')
    this.$table_view = $('&lt;button title="Show List View" class="option_toggle">&lt;i class="fas fa-list">&lt;/i>&lt;/button>')
    this.$graph_view = $('&lt;button title="Show Flow View" class="option_toggle option_selected">&lt;i class="fas fa-project-diagram">&lt;/i>&lt;/button>')
    
    this.addCreateOption()
    this.addImportOption()
    
    this.overview.addOpenDocumentOption("edit","fa-wrench")
    this.overview.addOption("launch", "fa-rocket", row => {
      Sessions.launch(row.name)
    })
    this.overview.addDeleteOption()
  }
  
  /**
  * add plugins cue properties and definitions to level schema
  *
  * replace previous cue properties and definitions
  * 
  * for cue in order to use it in graph editor and for whole chapter in order to use it for table view
  */
  append(plugin, schema) {
    if(this.plugins.hasOwnProperty(plugin)) {
      for(let t_prop in this.plugins[plugin].cue) {
        delete this.cue.properties[t_prop]
      }
      for(let t_def in this.plugins[plugin].definitions) {
        delete this.cue.definitions[t_def]

        delete this.chapter.definitions[t_def]
      }
    }
    
    if(schema.hasOwnProperty("definitions")) {
      Object.assign(this.cue.definitions, schema.definitions)

      Object.assign(this.chapter.definitions, schema.definitions)
    }
    
    Object.assign(this.cue.properties, schema.cue)
    
    this.plugins[plugin] = schema
  }
  
  /**
  * get current cue schema
  */
  getSchema() {
    return this.cue
  }
  
  /**
  * open leveleditor in main window
  *
  * @param {Object} data - json formatted level data
  * @param {string} data.name - name var is required
  * @param {boolean} [is_new=false] - if content is already stored in database.
  */
  openDocument(data, is_new, view) {
    return new Promise((resolve, reject) => {
      if(!data.hasOwnProperty("chapter")) {
        data.chapter = { chapter: [{ name: "START", "path": ["main"] }, {name: "QUIT", "view": {"position": {"x": 200,"y": 200}}, session:[{"quit":true}]}] }
      }
      if(!data.hasOwnProperty("config")) {
        data.config = {}
      }
      if(!data.hasOwnProperty("control")) {
        data.control = { pages: {} }
      }
      
      this.setCues(data.chapter)
      form.replace(data, 'level')
        .then(result => {
          if (result) {

            editor.file_menu.enable()
            editor.clearContent()
            // $('#content').html($('#editor_div'))
            
            //var tabs = form.tabrow('chapter', this.chapter, "graph")
            form.load(this.chapter, "chapter.chapter")
            form.showGraph("chapter.chapter") // GRAPH Edit
            
            //$('#content').prepend(tabs)
            
            if(is_new) {
              this.routeOptionsMenu("/level", data.name)
              
              $("#content").on("save", e => {
                this.routeOptionsMenu("/level/" + data.name, data.name)
              })
              
              form.changed = true
              editor.file_menu.config({delete:false})
            } else {
              this.routeOptionsMenu("/level/" + data.name, data.name)
            }
            
            let $sub_menu = $('&lt;h2>&lt;/h2>')
            $sub_menu.prepend(this.$graph_view)
            $sub_menu.prepend(this.$table_view)
            $sub_menu.prepend(this.$config)
            $sub_menu.prepend(this.$control_layout)
            $sub_menu.prepend(this.$launch)
            
            $(".option_toggle").removeClass("option_selected")
            this.$graph_view.addClass("option_selected")
            
            setGraphSchema(this.cue)

            var $title = form.editableTitle(data.name, 'div')
            $title.on('edited', function (e, param) {
              form.title = param.new_title
              form.changed = true
            })
            $sub_menu.prepend($title)
            $('#content').prepend($sub_menu)
          } else {
            routing.undo()
          }
          return resolve("done")
        })
    })
  }
  
  /**
  * create click routings for level options
  *
  * - launch: launch a session based on the selected level
  * - control_layout: switch to cue control editing page
  * - config: switch to level config editor
  * - table: switch to table view of level elements
  * - graph: switch to node graphical view of level elements
  */
  routeOptionsMenu(path, name) {
    routing.add({path:path, hash:"launch", link:this.$launch}, e => {
      Sessions.launch(name)
      $(".option_toggle").removeClass("option_selected")
      this.$launch.addClass("option_selected")
    })
    
    routing.add({path:path, hash:"control_layout", link:this.$control_layout}, e => {
      this.showControlLayout()
      $(".option_toggle").removeClass("option_selected")
      this.$control_layout.addClass("option_selected")
    })
    
    routing.add({path:path, hash:"config", link:this.$config}, e => {
      this.showConfig()
      $(".option_toggle").removeClass("option_selected")
      this.$config.addClass("option_selected")
    })

    routing.add({path:path, hash:"table", link:this.$table_view}, e => {
      form.show('chapter.chapter')
      $(".option_toggle").removeClass("option_selected")
      this.$table_view.addClass("option_selected")
    })
    
    routing.add({path:path, hash:"graph", link:this.$graph_view, symbolic:true}, e => {
      form.showGraph('chapter.chapter')
      $(".option_toggle").removeClass("option_selected")
      this.$graph_view.addClass("option_selected")
    })
  }
  
  /**
  * show config of the currently open level
  */
  showConfig() {
    form.load(this.level.config, 'config')
    form.show('config')
  }
  
  /**
  * show control page layout of the currently open level
  */
  showControlLayout() {
    form.load(this.level.control.properties.pages, 'control.pages')
    form.show('control.pages')
  }
  
  setCues(cues) {
    this.cuelist = []

    for(let chapter in cues) {
      for(let cue of cues[chapter]) {
        this.cuelist.push(chapter + '.' + cue.name)
      }
    }
    
    // removed because it conflicts once default cue properties are removed:
    /*
    this.cue.properties.dispatch.items['enum'] = this.cuelist
    this.cue.properties.listen.items.properties.followcue['enum'] = this.cuelist
    this.cue.properties.listen.items.properties.else['enum'] = this.cuelist
    this.level.control.properties.pages.properties = {}
    */
    for(let cue of this.cuelist) {
      this.level.control.properties.pages.properties[cue] = {
        "type":"array",
        "format":"table",
        "items":{
          "type":"string",
          "title":"cue",
          "enum":this.cuelist
        }
      }
    }
  }
  
}
</pre>
    </article>
</section>





		</div>
	</div>

	<div class="clearfix"></div>

	

</div>
</div>


    <div class="modal fade" id="searchResults">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <h4 class="modal-title">Search results</h4>
          </div>
          <div class="modal-body"></div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
          </div>
        </div><!-- /.modal-content -->
      </div><!-- /.modal-dialog -->
    </div>


<footer>

	 | <a href='https://plaitools.gitlab.io/documentation/plaiframe/'>Plaiframe Documentation</a> | <a href='https://plaitools.gitlab.io/documentation/plaiframe/plugins/'>Plugin Documentation</a> | <a href='https://gitlab.com/plaitools'>Plaitools on Gitlab</a>


	<span class="copyright">
	© 2020 Lasse Marburg, Benedikt Kaffai
	</span>

<span class="jsdoc-message">
	Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.4</a>
	
		on Fri Feb 5th 2021
	
	using the <a href="https://github.com/docstrap/docstrap">DocStrap template</a>.
</span>
</footer>

<script src="scripts/docstrap.lib.js"></script>
<script src="scripts/toc.js"></script>

    <script type="text/javascript" src="scripts/fulltext-search-ui.js"></script>


<script>
$( function () {
	$( "[id*='$']" ).each( function () {
		var $this = $( this );

		$this.attr( "id", $this.attr( "id" ).replace( "$", "__" ) );
	} );

	$( ".tutorial-section pre, .readme-section pre, pre.prettyprint.source" ).each( function () {
		var $this = $( this );

		var example = $this.find( "code" );
		exampleText = example.html();
		var lang = /{@lang (.*?)}/.exec( exampleText );
		if ( lang && lang[1] ) {
			exampleText = exampleText.replace( lang[0], "" );
			example.html( exampleText );
			lang = lang[1];
		} else {
			var langClassMatch = example.parent()[0].className.match(/lang\-(\S+)/);
			lang = langClassMatch ? langClassMatch[1] : "javascript";
		}

		if ( lang ) {

			$this
			.addClass( "sunlight-highlight-" + lang )
			.addClass( "linenums" )
			.html( example.html() );

		}
	} );

	Sunlight.highlightAll( {
		lineNumbers : true,
		showMenu : true,
		enableDoclinks : true
	} );

	$.catchAnchorLinks( {
        navbarOffset: 10
	} );
	$( "#toc" ).toc( {
		anchorName  : function ( i, heading, prefix ) {
			return $( heading ).attr( "id" ) || ( prefix + i );
		},
		selectors   : "#toc-content h1,#toc-content h2,#toc-content h3,#toc-content h4",
		showAndHide : false,
		smoothScrolling: true
	} );

	$( "#main span[id^='toc']" ).addClass( "toc-shim" );
	$( '.dropdown-toggle' ).dropdown();

    $( "table" ).each( function () {
      var $this = $( this );
      $this.addClass('table');
    } );

} );
</script>



<!--Navigation and Symbol Display-->


<!--Google Analytics-->



    <script type="text/javascript">
        $(document).ready(function() {
            SearcherDisplay.init();
        });
    </script>


</body>
</html>
